package com.ruoyi.bst.orderProd.service.impl;

import com.ruoyi.bst.orderProd.domain.OrderProdVO;
import com.ruoyi.bst.orderProd.service.OrderProdAssembler;
import com.ruoyi.bst.prodProcess.domain.ProdProcess;
import com.ruoyi.bst.prodProcess.domain.ProdProcessQuery;
import com.ruoyi.bst.prodProcess.domain.ProdProcessVO;
import com.ruoyi.bst.prodProcess.service.IProdProcessService;
import com.ruoyi.common.utils.collection.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author wjh
 * 2024/12/18
 */
@Service
public class OrderProdAssemblerImpl implements OrderProdAssembler {

    @Autowired
    private IProdProcessService prodProcessService;

    @Override
    public void assembleProcessList(List<OrderProdVO> list) {
        if (CollectionUtils.isEmptyElement(list)) {
            return;
        }

        ProdProcessQuery query = new ProdProcessQuery();
        query.setOrderProdIds(CollectionUtils.map(list, OrderProdVO::getId));
        Map<Long, List<ProdProcessVO>> group = prodProcessService.selectProdProcessList(query)
                .stream().collect(Collectors.groupingBy(ProdProcess::getOrderProdId));

        for (OrderProdVO prod : list) {
            List<ProdProcessVO> processList = group.get(prod.getId());
            if (processList == null) {
                processList = new ArrayList<>();
            }
            prod.setProcessList(processList);
        }

    }
}
